// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart' as bloc_base;

import 'package:wyatt_bloc_layout/wyatt_bloc_layout.dart';
import 'package:wyatt_ui_components/wyatt_ui_components.dart';
import 'package:wyatt_ui_layout/wyatt_ui_layout.dart';

abstract class TopNavigationBarLayoutCubitScreen<
    Cubit extends bloc_base.Cubit<State>,
    State extends Object> extends CubitScreenBase<Cubit, State> {
  const TopNavigationBarLayoutCubitScreen({
    this.custom,
    this.height = 60,
    this.barId,
    this.scaffoldFieldsWrapper,
    super.key,
  });

  final double height;
  final ComponentCallBack<TopNavigationBarComponent>? custom;
  final String? barId;
  final ScaffoldFieldsWrapper? scaffoldFieldsWrapper;

  @override
  Widget parent(BuildContext context, Widget child) =>
      StructuralLayout.withTopNavigationBar(
        barId: barId,
        custom: custom,
        height: height,
        scaffoldFieldsWrapper: scaffoldFieldsWrapper,
        body: child,
      );
}
